/**
 * This class file was automatically generated by the AXDR compiler that is part of jDLMS (http://www.openmuc.org)
 */

package org.openmuc.jdlms.internal.asn1.cosem;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jdlms.internal.asn1.axdr.AxdrType;

public class Cosem_Method_Descriptor implements AxdrType {

	public byte[] code = null;
	public Unsigned16 class_id = null;

	public Cosem_Object_Instance_Id instance_id = null;

	public Integer8 method_id = null;

	public Cosem_Method_Descriptor() {
	}

	public Cosem_Method_Descriptor(byte[] code) {
		this.code = code;
	}

	public Cosem_Method_Descriptor(Unsigned16 class_id, Cosem_Object_Instance_Id instance_id, Integer8 method_id) {
		this.class_id = class_id;
		this.instance_id = instance_id;
		this.method_id = method_id;
	}

	@Override
	public int encode(BerByteArrayOutputStream axdrOStream) throws IOException {

		int codeLength;

		if (code != null) {
			codeLength = code.length;
			for (int i = code.length - 1; i >= 0; i--) {
				axdrOStream.write(code[i]);
			}
		}
		else {
			codeLength = 0;
			codeLength += method_id.encode(axdrOStream);

			codeLength += instance_id.encode(axdrOStream);

			codeLength += class_id.encode(axdrOStream);

		}

		return codeLength;

	}

	@Override
	public int decode(InputStream iStream) throws IOException {
		int codeLength = 0;

		class_id = new Unsigned16();
		codeLength += class_id.decode(iStream);

		instance_id = new Cosem_Object_Instance_Id();
		codeLength += instance_id.decode(iStream);

		method_id = new Integer8();
		codeLength += method_id.decode(iStream);

		return codeLength;
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		BerByteArrayOutputStream axdrOStream = new BerByteArrayOutputStream(encodingSizeGuess);
		encode(axdrOStream);
		code = axdrOStream.getArray();
	}

	@Override
	public String toString() {
		return "sequence: {" + "class_id: " + class_id + ", instance_id: " + instance_id + ", method_id: " + method_id
				+ "}";
	}

}
