/**
 * This class file was automatically generated by the AXDR compiler that is part of jDLMS (http://www.openmuc.org)
 */

package org.openmuc.jdlms.internal.asn1.cosem;

import java.io.IOException;
import java.io.InputStream;

import org.openmuc.jasn1.ber.BerByteArrayOutputStream;
import org.openmuc.jdlms.internal.asn1.axdr.AxdrType;
import org.openmuc.jdlms.internal.asn1.axdr.types.AxdrEnum;

public class GET_Response implements AxdrType {

	public byte[] code = null;

	public static enum Choices {
		_ERR_NONE_SELECTED(-1),
		GET_RESPONSE_NORMAL(1),
		GET_RESPONSE_WITH_DATABLOCK(2),
		GET_RESPONSE_WITH_LIST(3),;

		private int value;

		private Choices(int value) {
			this.value = value;
		}

		public int getValue() {
			return this.value;
		}

		public static Choices valueOf(long tagValue) {
			Choices[] values = Choices.values();

			for (Choices c : values) {
				if (c.value == tagValue) {
					return c;
				}
			}
			return _ERR_NONE_SELECTED;
		}
	}

	private Choices choice;

	public Get_Response_Normal get_response_normal = null;

	public Get_Response_With_Datablock get_response_with_datablock = null;

	public Get_Response_With_List get_response_with_list = null;

	public GET_Response() {
	}

	public GET_Response(byte[] code) {
		this.code = code;
	}

	@Override
	public int encode(BerByteArrayOutputStream axdrOStream) throws IOException {
		if (code != null) {
			for (int i = code.length - 1; i >= 0; i--) {
				axdrOStream.write(code[i]);
			}
			return code.length;

		}
		if (choice == Choices._ERR_NONE_SELECTED) {
			throw new IOException("Error encoding AxdrChoice: No item in choice was selected.");
		}

		int codeLength = 0;

		if (choice == Choices.GET_RESPONSE_WITH_LIST) {
			codeLength += get_response_with_list.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(3);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GET_RESPONSE_WITH_DATABLOCK) {
			codeLength += get_response_with_datablock.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(2);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		if (choice == Choices.GET_RESPONSE_NORMAL) {
			codeLength += get_response_normal.encode(axdrOStream);
			AxdrEnum c = new AxdrEnum(1);
			codeLength += c.encode(axdrOStream);
			return codeLength;
		}

		// This block should be unreachable
		throw new IOException("Error encoding AxdrChoice: No item in choice was encoded.");
	}

	@Override
	public int decode(InputStream iStream) throws IOException {
		int codeLength = 0;
		AxdrEnum choosen = new AxdrEnum();

		codeLength += choosen.decode(iStream);
		resetChoices();
		this.choice = Choices.valueOf(choosen.getValue());

		if (choice == Choices.GET_RESPONSE_NORMAL) {
			get_response_normal = new Get_Response_Normal();
			codeLength += get_response_normal.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GET_RESPONSE_WITH_DATABLOCK) {
			get_response_with_datablock = new Get_Response_With_Datablock();
			codeLength += get_response_with_datablock.decode(iStream);
			return codeLength;
		}

		if (choice == Choices.GET_RESPONSE_WITH_LIST) {
			get_response_with_list = new Get_Response_With_List();
			codeLength += get_response_with_list.decode(iStream);
			return codeLength;
		}

		throw new IOException("Error decoding AxdrChoice: Identifier matched to no item.");
	}

	public void encodeAndSave(int encodingSizeGuess) throws IOException {
		BerByteArrayOutputStream axdrOStream = new BerByteArrayOutputStream(encodingSizeGuess);
		encode(axdrOStream);
		code = axdrOStream.getArray();
	}

	public Choices getChoiceIndex() {
		return this.choice;
	}

	public void setget_response_normal(Get_Response_Normal newVal) {
		resetChoices();
		choice = Choices.GET_RESPONSE_NORMAL;
		get_response_normal = newVal;
	}

	public void setget_response_with_datablock(Get_Response_With_Datablock newVal) {
		resetChoices();
		choice = Choices.GET_RESPONSE_WITH_DATABLOCK;
		get_response_with_datablock = newVal;
	}

	public void setget_response_with_list(Get_Response_With_List newVal) {
		resetChoices();
		choice = Choices.GET_RESPONSE_WITH_LIST;
		get_response_with_list = newVal;
	}

	private void resetChoices() {
		choice = Choices._ERR_NONE_SELECTED;
		get_response_normal = null;
		get_response_with_datablock = null;
		get_response_with_list = null;
	}

	@Override
	public String toString() {
		if (choice == Choices.GET_RESPONSE_NORMAL) {
			return "choice: {get_response_normal: " + get_response_normal + "}";
		}

		if (choice == Choices.GET_RESPONSE_WITH_DATABLOCK) {
			return "choice: {get_response_with_datablock: " + get_response_with_datablock + "}";
		}

		if (choice == Choices.GET_RESPONSE_WITH_LIST) {
			return "choice: {get_response_with_list: " + get_response_with_list + "}";
		}

		return "unknown";
	}

}
